| IGLib 1.7.2 The IGLib base library for development of numerical, technical and business applications.

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Events Macros
Public Member Functions | List of all members
IG.Num.ScalarFunctionScriptController Class Reference

Class for building scalar functions from scripts, used by GUI elements. More...

Inheritance diagram for IG.Num.ScalarFunctionScriptController:
[legend]
Collaboration diagram for IG.Num.ScalarFunctionScriptController:
[legend]

## Public Member Functions
| ScalarFunctionScriptController ()
| Creates a DTO for storing state of a scalar function object of any type More...
| ScalarFunctionScriptController (int length)
| Creates a DTO for storing a scalar function object of any vector type, with specified dimension. More...
Public Member Functions inherited from IG.Num.ScalarFunctionScriptControllerBase< ScalarFunctionType >
| ScalarFunctionScriptControllerBase ()
| Default constructor, sets IsNull to true. More...
| ScalarFunctionScriptControllerBase (int spaceDimension)
| Constructor, prepares the current DTO for storing a scalar function of the specified dimension. More...
virtual string | ConvertParameterNamesToString (params string[] parameterNames)
| Converts an array of parameter names to a delimited single string that contains these names, and returns this string. More...
virtual string[] | ConvertParameterNamesToArray (string parameterNamesString)
| Converts a single string containing parameter names in delimited form to an array of individual parameter names, and returns this array. More...
virtual string | ConvertFunctionDefinitionsToString (params string[] functionDefinitions)
| Converts an array of function definition strings to a delimited single string that contains these defintions, and returns this string. More...
virtual string[] | ConvertFunctionDefinitionsToArray (string functionDefinitionsString)
| Converts a single string containing function definitions in delimited form to an array of individual function definition strings, and returns this array. More...
virtual string | GetParametersString ()
| Returns function parameter names in form of delimited string that contains all function parameter names. More...
virtual void | SetParametersString (string parametersString)
| Sets function parameter names through a string containing delimided parameters names. More...
string | GetGradientDefinitionSingleString ()
| Returns a string that contains delimited definitions of all gradient components. More...
void | SetGradientDefinitionSingleString (string definitionsString)
| Sets definitions of components of function gradients by specifying a string that contains these definitions in delimited form (without any enclosing brackets). More...
virtual void | SetGradientComponentDefiniton (int whichComponent, string gradientComponentDefinition)
| Sets a definition of the specified gradient components. More...
virtual void | InvalidateDimension ()
| Invalidates dimension of function domain. All dependent data is invalidated. More...
virtual void | InvalidateParameterNames ()
| Invalidates names of parameters. This also means that function value definition and function gradient definitions are invalidated, if present. More...
virtual void | InvalidateValueDefinition ()
| Invalidates definition of function value. More...
virtual void | InvalidateGradientDefinition ()
| Invalidates definition of function gradient. More...
bool | GetIsLoaderConsistent ()
| Returns a flag telling whether the loader is currently consistent with function definition contained in the DTO. More...
virtual ScalarFunctionLoader | GetFunctionLoader ()
| Returns the loader that can create a scalar function according to the definition from the current DTO. More...
virtual void | SetFunctionLoader (ScalarFunctionLoader loader)
| Sets the loader that can create a scalar function according to the definition from the current DTO. More...
LoadableScalarFunctionBase | GetFunction ()
| Returns a scalar function that is created from the funciton definitio on the current function DTO. More...
void | DataToFunctionLoader ()
| Copies data of the form to function loader. More...
virtual InputOutputDataDefiniton | GetDataDefinitionObject (bool setBoundsAndDefaults=false, IBoundingBox inputBounds=null, IBoundingBox outputBounds=null)
| Creates and returns a data definition object for input parametera and output values of the current function DTO. More...
override string | ToString ()
| Returns human readable string representation of the current object. More...

## Additional Inherited Members
Static Public Member Functions inherited from IG.Num.ScalarFunctionScriptControllerBase< ScalarFunctionType >
static void | CreateParameterNamesArray (string namesString, string separator, ref string[] namesArray, bool trimSpaces=true)
| Parses a string that contains delimited parameter names, extract an array of individual parameter names from it, and stores names to the specified array (which is reallocated if necessary). More...
static void | CreateParameterNamesArray (string namesString, string[] separators, ref string[] namesArray, bool trimSpaces=true, bool allowMultipleSeparators=false)
| Parses a string that contains delimited parameter names, extract an array of individual parameter names from it, and stores names to the specified array (which is reallocated if necessary). More...
static void | CreateFunctionDefinitionsArray (string namesString, string separator, ref string[] namesArray, bool trimSpaces=true)
| Parses a string that contains delimited function definitions, extract an array of individual function definitions from it, and stores individual string definitions to the specified array (which is reallocated if necessary). More...
static void | CreateFunctionDefinitionsArray (string namesString, string[] separators, ref string[] namesArray, bool trimSpaces=true, bool allowMultipleSeparators=false)
| Parses a string that contains delimited parameter names, extract an array of individual parameter names from it, and stores names to the specified array (which is reallocated if necessary). More...
static string | CreateParameterNamesString (string[] namesArray, string separator, bool insertNewLines=false, bool insertSpaces=true)
| Constructs a delimited string cotaining parameter names, from the specified array of parameter names. More...
static string | CreateFunctionDefinitionsString (string[] definitionsArray, string separator, bool insertNewLines=false, bool insertSpaces=true)
| Construct a delimited string cotaining function definitons, from the specified array of individual string function definitions. More...
static string[] | GenerateParameterOrVariableNames (int dimension, string baseName="x", int startIndex=0, int numPlaces=2)
| Generates and returns an array of a specified number of variable or parameter names, composed of a base name and numerical string corresponding to the consecutive number of the variable. More...
static string | GenerateFuctonParameterName (int whichParameter, string baseName="x", int startIndex=0, int numPlaces=2)
| Generates and returns a pre-defined name of the specified variable or function parameter , composed of the specified base name and numerical string corresponding to the consecutive number of the variable. More...
static string | ToString (ScalarFunctionScriptControllerBase< ScalarFunctionType > sc)
| Returns a string representation of the specified ScalarFunctionScriptController object. More...
static void | SaveJson (ScalarFunctionScriptController functionController, string filePath, InputOutputDataDefiniton dataDefinition)
| Saves (serializes) the specified script-based scalar function controller to the specified JSON file. If the file already exists, contents either overwrites the file or is appended at the end, dependent on the value of the append flag. More...
static void | SaveJson (ScalarFunctionScriptController functionController, string filePath, bool append=false, InputOutputDataDefiniton dataDefinition=null)
| Saves (serializes) the specified script-based scalar function controller to the specified JSON file. If the file already exists, contents either overwrites the file or is appended at the end, dependent on the value of the append flag. More...
static void | LoadJson (string filePath, ref ScalarFunctionScriptController controllerRestored)
| Restores (deserializes) a script-based scalar function controller from the specified file in JSON format. More...
static void | LoadJson (string filePath, ref ScalarFunctionScriptController controllerRestored, ref ScalarFunctionScriptDto dto)
| Restores (deserializes) a script-based scalar function controller from the specified file in JSON format. More...
static void | LoadJson (string filePath, ref ScalarFunctionScriptController controllerRestored, ref InputOutputDataDefiniton dataDef)
| Restores (deserializes) a script-based scalar function controller from the specified file in JSON format. More...
static void | SaveCsv (IVector vec, string filePath)
| Saves the specified vector to a CSV file. It the specified file already exists then it is overwritten. Constant UtilCsv.DefaultCsvSeparator is used as separator. More...
static void | SaveCsv (IVector vec, string filePath, string separator)
| Saves the specified vector to a CSV file. It the specified file already exists then it is overwritten. More...
static void | SaveCsv (IVector vec, string filePath, bool append)
| Saves the specified vector to a CSV file. Constant UtilCsv.DefaultCsvSeparator is used as separator in CSV. More...
static void | SaveCsv (IVector vec, string filePath, string separator, bool append)
| Saves the specified vector to a CSV file. More...
static void | LoadCsv (string filePath, ref IVector vecRestored)
| Reads a vector from a CSV file. Constant UtilCsv.DefaultCsvSeparator is used as separator in CSV file. If there are no components then a null vector is returned by this method (no exceptions thrown). If there are more than one rows in the CSV file then vector is read from the first row. More...
static void | LoadCsv (string filePath, string separator, ref IVector vecRestored)
| Reads a vector written in CSV format from a file. If there are no components then a null vector is returned by this method (no exceptions thrown). If there are more than one rows in the CSV file then vector is read from the first row. More...
static void | LoadCsv (string filePath, int rowNum, ref IVector vecRestored)
| Reads a vector from the specified row of a CSV file. Constant UtilCsv.DefaultCsvSeparator is used as CSV separator. If the specified row does not exisist in the file then exception is thrown. More...
static void | LoadCsv (string filePath, int rowNum, string separator, ref IVector vecRestored)
| Reads a vector from the specified row of a CSV file. If the specified row does not exisist in the file then exception is thrown. More...
Protected Member Functions inherited from IG.Num.ScalarFunctionScriptControllerBase< ScalarFunctionType >
void | CopyDataToFunctionLoader ()
| Copies function deffinition data from the current function DTO to the internal function loader. More...
void | CopyDataToFunctionLoader (ScalarFunctionLoader loader)
| Copies function deffinition data from the current function DTO to the specified function loader. More...
Protected Attributes inherited from IG.Num.ScalarFunctionScriptControllerBase< ScalarFunctionType >
string | _name
string | _parametersString
string | _gradientsSingleString
Static Protected Attributes inherited from IG.Num.ScalarFunctionScriptControllerBase< ScalarFunctionType >
static double | _defaultLowerBound = 0.0
static double | _defaultUpperBound = 1.0
Properties inherited from IG.Num.ScalarFunctionScriptControllerBase< ScalarFunctionType >
virtual int | Dimension`[get, set]`
| Dimension of the parameter space. More...
virtual string | Name`[get, set]`
| Scalar function name. More...
virtual string | Description`[get, set]`
| Scalar function description. More...
virtual bool | IsValueDefined`[get]`
| Specifies whether value is defined for the funciton represented by the current DTO. More...
virtual bool | IsGradientDefined`[get]`
| Specifies whether gradient is defined for the funciton represented by the current DTO. More...
virtual string | ValueDefinitonString`[get, set]`
| Definition of function value. More...
virtual string[] | ParameterNames`[get, set]`
| Names of function parameters. More...
virtual string[] | GradientDefinitionStrings`[get, set]`
| Gradient definition strings (separately for each gradient component). More...
static string | DefaultParameterNamesSeparator`[get, protected set]`
| Default parameter names separator, separates parametr names when stated in a single string. More...
static string | DefaultFunctionsSeparator`[get, private set]`
| Default functions separator, separates string definitions of functions when stated in a single string. More...
string | ParameterNamesSeparator`[get, protected set]`
| Separator string that is used to separate parameter names when stated in a single string. More...
string | FunctionsSeparator`[get, private set]`
| Separator string that is used to separate function definitions when stated in a single state. More...
bool | IsLoaderConsistent`[get, set]`
| A flag indicateing whether the loader is currently consistent with the function definition contained in the current DTO. More...
virtual ScalarFunctionLoader | FunctionLoader`[get, set]`
| Object that is responsible for creation of scalar function objects that correspond to the definitions found on the current scalar function DTO. More...
LoadableScalarFunctionBase | Function`[get]`
| Scalar function (of type IScalarFunction) created on basis of definition in this DTO. More...

## Detailed Description

Class for building scalar functions from scripts, used by GUI elements.

$A Igor Feb16;

## Constructor & Destructor Documentation

IG.Num.ScalarFunctionScriptController.ScalarFunctionScriptController | ( |  | ) |
| inline

Creates a DTO for storing state of a scalar function object of any type

IG.Num.ScalarFunctionScriptController.ScalarFunctionScriptController | ( | int | length | ) |
| inline

Creates a DTO for storing a scalar function object of any vector type, with specified dimension.

Parameters

  length | Vector dimension.

The documentation for this class was generated from the following file:

- igbase/data/serialization/dtos/ScalarFunctionScriptController.cs